/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : FuzzyVariable.h                                           */
/*************************************************************************/
/*  Each fuzzy variable is composed of a bunch of fuzzy sets. These
    fuzzy sets define a different fuzzy classes for this variable. 
    For example, for fuzzy variable Age, we can define Infant, Baby, Young,
    Teenager, MidleAge, Old definitions by using a different Fuzzy sets.
*/
/*************************************************************************/

#ifndef _FUZZYVARIABLE_H
#define _FUZZYVARIABLE_H

#include <iostream.h>
#include "FuzzySet.h"
#include "MembershipFunction.h"
#include "Function.h"

class FuzzyVariable 
{
   public:

     void addClass(FuzzySet );
     float getValueWithClassIndex(float,int);
     int getValueWithClassIndex(int,int);

     getClassNumber(float);

     Function *copyWithCutOffClassIndex(float,int);
     //* Constructors

     FuzzyVariable(FuzzySet );
     FuzzyVariable();

     //* Destructor

     ~FuzzyVariable();

     //* Standard operators

     FuzzyVariable operator=(const FuzzyVariable&);


     friend ostream&operator<<(ostream&,const FuzzyVariable&);

   private:

     FuzzySet *myClasses;
          int index;

}; // end of class FuzzyVariable

#endif
